#include "testlib.h"  
#include <cstring>
#include <algorithm>
#include <iostream>


using namespace std;

bool is_square(long long v) {
    long long l = 0, r = min(1LL<<30, v + 1);
    while (l < r - 1) {
        long long mid = (l + r) >> 1;
        long long prod = mid * mid;
        if (prod == v)
            return true;
        else if (prod > v)
            r = mid;
        else
            l = mid;
    }
    return r * r == v;
}

long long check(long long prod, long long a, long long b)
{
    if (a <= 0 || b <= 0) return -1;
    long long lprod = 1LL * a * b;
    if (prod % lprod != 0 || !is_square(prod / lprod)) {
        return -1;
    }
    return a + b;
}

int main(int argc, char* argv[]) {
    registerTestlibCmd(argc, argv);
    int t = inf.readInt();
    for (int i = 0; i < t; ++i) {
        int a = inf.readInt();
        int b = inf.readInt();
        long long c = 1LL * a * b;
        long long ja = ans.readInt(), jb = ans.readInt();
        long long jsum = check(c, ja, jb);
        if (jsum == -1) {
            quitf(_fail, "Jury has incorrect answer on test %d.", i + 1);
            return 0;
        }
        long long pa = ouf.readLong(), pb = ouf.readLong();
        long long psum = check(c, pa, pb);
        if (psum == -1) {
            quitf(_wa, "Participant has incorrect answer on test %d.", i + 1);
            return 0;
        }
        if (psum == jsum)
            continue;
        else if (psum < jsum) 
            quitf(_fail, "Participant has better answer on test %d.", i + 1);
        else if (psum > jsum)
            quitf(_wa, "Jury has better answer on test %d.", i + 1);         
    }
    quitf(_ok, "%d answers are OK", t);
    return 0;
}