#include <cstdio>
#include <set>
#include <map>
#include <algorithm>
using namespace std;

set <int> v;
const int N = 16;
int divisors[N];
int cap[N];

void add(int x)
{
	if (v.count(x))
		v.erase(x);
	else
		v.insert(x);
}

void process(int v)
{
	for (int i = 2; i * i <= v; ++i)
	{
		while (v % i == 0)
			add(i),
			v /= i;
	}
	if (v != 1)
		add(v);
}

int n = 0;
int answer;
pair <int, int> gud;

const int MX = 1e9;

int dp[1 << N];

inline int mul(int a, int b, int CAP) {
	if (a == -1 || a > CAP)
		return -1;
	return a * b;
}

void solve(int a, int b) {
	answer = a + b;
	n = 0;
	v.clear();
	gud = { a, b };
	process(a);
	process(b);
	for (auto x : v)
		divisors[n] = x,
		cap[n++] = MX / x;
	const int MSK = 1 << n;
	dp[0] = 1;	
	for (int i = 1; i < MSK; ++i) {
		for (int j = 0; j < n; ++j)
			if (i & (1 << j))
			{
				dp[i] = mul(dp[i ^ (1 << j)], divisors[j], cap[j]);
				break;
			}
	}

	for (int i = 0; i < MSK; ++i) {
		int a = dp[i];
		int b = dp[(MSK - 1) ^ i];
		if (a == -1 || b == -1)
			continue;
		if (a + b < answer)
			gud = { a, b },
			answer = a + b;
	}
	printf("%d %d\n", gud.first, gud.second);
}

int main()
{
	int t;
	scanf("%d", &t);
	while (t--) {
		int a, b;
		scanf("%d %d", &a, &b);
		solve(a, b);
	}
	return 0;
}