#include <cstdio>
#include <set>
#include <map>
#include <algorithm>
using namespace std;

bool is_square(long long v) {
	long long l = 0, r = min(1LL << 30, v + 1);
	while (l < r - 1) {
		long long mid = (l + r) >> 1;
		long long prod = mid * mid;
		if (prod == v)
			return true;
		else if (prod > v)
			r = mid;
		else
			l = mid;
	}
	return r * r == v;
}

int gcd(int a, int b)
{
	while (a && b)
		if (a > b)
			a %= b;
		else
			b %= a;
	return a ? a : b;
}

const int CAP = 1e9;

void solve(int a, int b) {
	{
		int g = gcd(a, b);
		a /= g, b /= g; 
	}//That's not necessary though
	long long prod = 1LL * a * b;
	long long val;
	for (int i = 2; (val = i * i) <= CAP && val <= prod; ++i) {
		while (prod % val == 0)
			prod /= val;			
	}
	if (is_square(prod))
	{
		printf("1 1\n");
		return;
	}
	int start = sqrt(prod) + 1;
	for (int i = start; ; --i) {
		if (prod % i == 0)
		{
			printf("%I64d %I64d\n", prod / i, (long long)i);
			return;
		}
	}
}

int main()
{
	int t;
	scanf("%d", &t);
	while (t--) {
		int a, b;
		scanf("%d %d", &a, &b);
		solve(a, b);
	}
	return 0;
}