import java.util.*;
import java.io.*;

public class figure_dp_java {
    FastScanner in;
    PrintWriter out;

    private static final int MAX_C = 1_000_000_000;
    private static final int[] dx = new int[]{1, -1, 0, 0};
    private static final int[] dy = new int[]{0, 0, 1, -1};

    private long encode(int x, int y) {
        return (x + MAX_C) * (2L * MAX_C + 1) + y + MAX_C;
    }

    int diff;

    void dfs(Set<Long> cells,
             Set<Long> used,
             int x, int y, int mirror,
             List<int[]> newCells) {
        used.add(encode(x, y));
        newCells.add(new int[]{2 * mirror - x - 1, y});
        if (--diff <= 0) {
            return;
        }
        for (int it = 0; it < 4; it++) {
            int nx = x + dx[it];
            int ny = y + dy[it];
            long code = encode(nx, ny);
            if (cells.contains(code) && !used.contains(code)) {
                dfs(cells, used, nx, ny, mirror, newCells);
                if (diff <= 0) {
                    return;
                }
            }
        }
    }

    public void solve() throws IOException {
        int tests = in.nextInt();
        while (tests-- > 0) {
            int n = in.nextInt();
            int k = in.nextInt();
            Set<Long> cells = new HashSet<>();
            List<int[]> newCells = new ArrayList<>();
            int mlx = Integer.MAX_VALUE;
            int mly = 0;
            for (int i = 0; i < n; i++) {
                int x = in.nextInt();
                int y = in.nextInt();
                cells.add(encode(x, y));
                newCells.add(new int[]{x, y});
                if (mlx > x || (mlx == x && mly > y)) {
                    mlx = x;
                    mly = y;
                }
            }
            Set<Long> used = new HashSet<>();
            diff = k - newCells.size();
            dfs(cells, used, mlx, mly, mlx, newCells);
            out.println("L " + mlx);
            for (int[] cell : newCells) {
                out.println(cell[0] + " " + cell[1]);
            }
        }
    }

    public void run() {
        try {
            in = new FastScanner();
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        FastScanner() {
            br = new BufferedReader(new InputStreamReader(System.in));
        }

        String next() {
            while (st == null || !st.hasMoreTokens()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(next());
        }
    }

    public static void main(String[] arg) {
        new figure_dp_java().run();
    }
}