#include <bits/stdc++.h>

#ifndef LOCAL
#define cerr dolor_sit_amet
#endif

#define mp make_pair
#define sz(x) ((int)((x).size()))
#define X first
#define Y second

using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair < int , int > ipair;
typedef pair < ll , ll > lpair;
const int IINF = 0x3f3f3f3f;
const ll LINF = 0x3f3f3f3f3f3f3f3fll;
const double DINF = numeric_limits<double>::infinity();
const ll MOD = 1000000007;
const double EPS = 1e-9;
const int DX[] = { 1,  0, -1,  0,  1, -1,  1, -1};
const int DY[] = { 0,  1,  0, -1,  1, -1, -1,  1};
ll gcd(ll a, ll b) { return b ? gcd(b, a % b) : a; }
ll sqr(ll x) { return x*x; } ll sqr(int x) { return (ll)x*x; }
double sqr(double x) { return x*x; } ld sqr(ld x) { return x*x; }

// ========================================================================= //

struct Vec2
{
	ll x, y;
	
	Vec2() {}
	Vec2(ll nx, ll ny) : x(nx), y(ny) {}

	Vec2 operator + (const Vec2 & b) const { return { x+b.x, y+b.y }; }
	Vec2 operator - (const Vec2 & b) const { return { x-b.x, y-b.y }; }
	Vec2 operator - () const { return { -x, -y }; }
	Vec2 operator * (ll b) const { return { x*b, y*b }; }

	Vec2 & operator += (const Vec2 & b) { x+=b.x; y+=b.y; return *this; }
	Vec2 & operator -= (const Vec2 & b) { x-=b.x; y-=b.y; return *this; }
	Vec2 & operator *= (ll b) { x*=b; y*=b; return *this; }

	bool operator == (const Vec2 & b) const { return x==b.x && y==b.y; }
	bool operator != (const Vec2 & b) const { return x!=b.x && y!=b.y; }
	bool operator <  (const Vec2 & b) const { return x==b.x ? y<b.y : x<b.x; }
	bool operator <= (const Vec2 & b) const { return x==b.x ? y<=b.y : x<b.x; }
	bool operator >  (const Vec2 & b) const { return x==b.x ? y>b.y : x>b.x; }
	bool operator >= (const Vec2 & b) const { return x==b.x ? y>=b.y : x>b.x; }

    int getHalf() const
    {
        if (y > 0)
            return 0;
        if (y == 0 && x >= 0)
            return 0;
        return 1;
    }
};

istream & operator >> (istream & in, Vec2 & v) { return in >> v.x >> v.y; }
ostream & operator << (ostream & out, const Vec2 & v) { return out << v.x << " " << v.y; }
Vec2 operator * (ll b, const Vec2 & a) { return { b*a.x, b*a.y }; }
ll dot(const Vec2 & a, const Vec2 & b) { return a.x*b.x + a.y*b.y; }
ll cross(const Vec2 & a, const Vec2 & b) { return a.x*b.y - a.y*b.x; }
ll length2(const Vec2 & a) { return a.x*a.x + a.y*a.y; }
double length(const Vec2 & a) { return sqrt(a.x*a.x + a.y*a.y); }

void solve()
{
    int n;
    cin >> n;
    vector < Vec2 > p(n);
    for (int i = 0; i < n; ++i)
        cin >> p[i];
    ll ans = 1LL*n*(n-1)*(n-2) / 6;
    
    for (int i = 0; i < n; ++i)
    {
        Vec2 v = p[i];
        vector < int > order;
        for (int j = 0; j < n; ++j)
            if (i != j)
                order.push_back(j);
        sort(order.begin(), order.end(), [&](int ia, int ib)
        {
            Vec2 a = p[ia] - v;
            Vec2 b = p[ib] - v;
            int h1 = a.getHalf();
            int h2 = b.getHalf();
            if (h1 != h2)
                return h1 < h2;
            ll c = cross(a, b);
            if (c != 0)
                return c > 0;
            return length2(a) < length2(b);
        });
        ans -= (n - 1) * (n - 2) / 2;
        int j2 = 0;
        for (int j = 0; j < n - 1; ++j)
        {
            Vec2 v1 = p[order[j]] - v;
            while (j2 < j + (n - 1))
            {
                Vec2 v2 = p[order[j2 % (n - 1)]] - v;
                if ((cross(v1, v2) > 0 && dot(v1, v2) > 0) ||
                    (cross(v1, v2) == 0 && dot(v1, v2) > 0 && length2(v1) <= length2(v2)))

                    ++j2;
                else
                    break;
            }
            ans += j2 - j - 1;
        }
        /*for (int j3 : order)
            for (int j4 : order)
            {
                Vec2 v3 = p[j3] - v;
                Vec2 v4 = p[j4] - v;
                if ((cross(v3, v4) > 0  && dot(v3, v4) > 0) ||
                    (cross(v3, v4) == 0 && dot(v3, v4) > 0 && j3 < j4))
                    ++ans;
            }*/
    }

    cout << ans << "\n";
}

int main()
{
    ios::sync_with_stdio(false);
    int t;
    cin >> t;
    while (t--)
        solve();

    return 0;
}
